import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetPackageVersionAssetResultFilterSensitiveLog, } from "../models/models_0";
import { de_GetPackageVersionAssetCommand, se_GetPackageVersionAssetCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetPackageVersionAssetCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodeArtifactControlPlaneService", "GetPackageVersionAsset", {})
    .n("CodeartifactClient", "GetPackageVersionAssetCommand")
    .f(void 0, GetPackageVersionAssetResultFilterSensitiveLog)
    .ser(se_GetPackageVersionAssetCommand)
    .de(de_GetPackageVersionAssetCommand)
    .build() {
}
