import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { PublishPackageVersionRequestFilterSensitiveLog, } from "../models/models_0";
import { de_PublishPackageVersionCommand, se_PublishPackageVersionCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class PublishPackageVersionCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodeArtifactControlPlaneService", "PublishPackageVersion", {})
    .n("CodeartifactClient", "PublishPackageVersionCommand")
    .f(PublishPackageVersionRequestFilterSensitiveLog, void 0)
    .ser(se_PublishPackageVersionCommand)
    .de(de_PublishPackageVersionCommand)
    .build() {
}
